/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * GrappaForm.java
 *
 * Created on 2011/03/29, 1:04:27
 */
package com.snail.grappaexam;

import att.grappa.Element;
import att.grappa.Graph;
import att.grappa.GrappaAdapter;
import att.grappa.GrappaConstants;
import att.grappa.GrappaPanel;
import att.grappa.GrappaPoint;
import att.grappa.GrappaSupport;
import att.grappa.Parser;
import att.grappa.Subgraph;
import java.awt.Graphics;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;
import java.io.ByteArrayInputStream;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;

/**
 *
 * @author Atsushi
 */
public class GrappaForm extends javax.swing.JFrame implements GrappaConstants {

    /** Creates new form GrappaForm */
    public GrappaForm() {
        initComponents();

        // デモ用のグラフの読み込み
        try {
            txtDtoText.setText(
                    "digraph \"サンプル\" {\n" +
                    "graph [label = \"サンプルグラフ\";];\n" +
                    "\na -> b;\nb -> c;\nc -> a;\nb -> d;\nd -> c;\n" +
                    "}");
            txtDtoText.setCaretPosition(0);
            scrlGraph.setViewportView(createGraph());

        } catch (Exception ex) {
            Logger.getLogger(GrappaForm.class.getName()).log(Level.SEVERE, null, ex);
        }

    }

    public GrappaPanel createGraph() throws Exception {
        CommandExecutor exec = new CommandExecutor("/opt/local/bin/");
        CommandResult res = exec.exec(
                txtDtoText.getText(),
                "/opt/local/bin/" + cmbAlgorithm.getSelectedItem().toString());

        System.out.println("STDOUT:" + res.getStdout());
        System.err.println("STDERR:" + res.getStderr());

        ByteArrayInputStream bin = new ByteArrayInputStream(res.getStdout().getBytes("UTF-8"));
        Parser program = new Parser(bin, System.err);
        program.parse();

        Graph graph = program.getGraph();
        graph.setEditable(true);
        graph.setMenuable(true);

        GrappaPanel gp = new GrappaPanel(graph);
        gp.addGrappaListener(new GrappaAdapter(){
            @Override
            public void grappaClicked(Subgraph subg,
                   Element elem,
                   GrappaPoint pt,
                   int modifiers,
                   int clickCount,
                   GrappaPanel panel){

                JOptionPane.showMessageDialog(
                        null, "Node \"" + elem.getName() + " \"Clicked", "EventHandler",
			JOptionPane.INFORMATION_MESSAGE);
                
            }
        });
        gp.setScaleToFit(false);
        return gp;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jSplitPane1 = new javax.swing.JSplitPane();
        pnlHeader = new javax.swing.JPanel();
        scrlDotText = new javax.swing.JScrollPane();
        txtDtoText = new javax.swing.JTextArea();
        pnlButton = new javax.swing.JPanel();
        cmbAlgorithm = new javax.swing.JComboBox();
        btnUpdate = new javax.swing.JButton();
        btnPrint = new javax.swing.JButton();
        scrlGraph = new javax.swing.JScrollPane();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setMinimumSize(new java.awt.Dimension(240, 320));
        setSize(new java.awt.Dimension(640, 640));

        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane1.setPreferredSize(new java.awt.Dimension(240, 102));

        pnlHeader.setLayout(new javax.swing.BoxLayout(pnlHeader, javax.swing.BoxLayout.LINE_AXIS));

        txtDtoText.setColumns(20);
        txtDtoText.setRows(5);
        txtDtoText.setPreferredSize(new java.awt.Dimension(120, 80));
        scrlDotText.setViewportView(txtDtoText);

        pnlHeader.add(scrlDotText);

        pnlButton.setMaximumSize(new java.awt.Dimension(100, 85));
        pnlButton.setMinimumSize(new java.awt.Dimension(100, 85));
        pnlButton.setPreferredSize(new java.awt.Dimension(100, 85));
        pnlButton.setLayout(new javax.swing.BoxLayout(pnlButton, javax.swing.BoxLayout.Y_AXIS));

        cmbAlgorithm.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "dot", "neato", "twopi", "circo", "fdp", "sfdp" }));
        pnlButton.add(cmbAlgorithm);

        btnUpdate.setText("Update");
        btnUpdate.setMaximumSize(new java.awt.Dimension(120, 29));
        btnUpdate.setMinimumSize(new java.awt.Dimension(120, 29));
        btnUpdate.setPreferredSize(new java.awt.Dimension(120, 29));
        btnUpdate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnUpdateActionPerformed(evt);
            }
        });
        pnlButton.add(btnUpdate);

        btnPrint.setText("Print");
        btnPrint.setMaximumSize(new java.awt.Dimension(120, 29));
        btnPrint.setMinimumSize(new java.awt.Dimension(120, 29));
        btnPrint.setPreferredSize(new java.awt.Dimension(120, 29));
        btnPrint.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnPrintActionPerformed(evt);
            }
        });
        pnlButton.add(btnPrint);

        pnlHeader.add(pnlButton);

        jSplitPane1.setTopComponent(pnlHeader);
        jSplitPane1.setRightComponent(scrlGraph);

        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnUpdateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnUpdateActionPerformed
        try {
            scrlGraph.setViewportView(createGraph());
        } catch (Exception ex) {
            Logger.getLogger(GrappaForm.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_btnUpdateActionPerformed

    private void btnPrintActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnPrintActionPerformed

        PrinterJob printJob = PrinterJob.getPrinterJob();
        printJob.setPrintable(new Printable() {

            @Override
            public int print(Graphics graphics, PageFormat pageFormat, int pageIndex) throws PrinterException {
                if (pageIndex > 0) {
                    return NO_SUCH_PAGE;
                }

                try {
                    createGraph().print(graphics, pageFormat, 0);
                    return Printable.PAGE_EXISTS;
                } catch (Exception ex) {
                    Logger.getLogger(GrappaForm.class.getName()).log(Level.SEVERE, null, ex);
                }
                return Printable.NO_SUCH_PAGE;
            }
        });

        if (printJob.printDialog()) {
            try {
                printJob.print();
            } catch (Exception ex) {
                Logger.getLogger(GrappaForm.class.getName()).log(Level.SEVERE, null, ex);
            }
        }


    }//GEN-LAST:event_btnPrintActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new GrappaForm().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnPrint;
    private javax.swing.JButton btnUpdate;
    private javax.swing.JComboBox cmbAlgorithm;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JPanel pnlButton;
    private javax.swing.JPanel pnlHeader;
    private javax.swing.JScrollPane scrlDotText;
    private javax.swing.JScrollPane scrlGraph;
    private javax.swing.JTextArea txtDtoText;
    // End of variables declaration//GEN-END:variables
}
